cube = function(x) 
{
 y=x^3
 return(y)
}
#
incircle= function(x, y)
{
  f=sqrt(x^2+y^2)
  z=(f<1)
  return(list(distance=f, inside=z))
}
#
lcomb= function(x,y)
{
  return(5*x+10*y)
}
##
# Programming structures
#
# For loops
#
y=(1:10)^2
z=rep(0,10)
for (n in (1:10))
{
  z[n]=n^2
}
#
z=rep(0,10)
for (n in c(2,8,5,3))
{
  z[n]=n^2
}
#
# IF
#
a=3
if (a<4) 
  {
  x=9
}

if (a<4) x=3 else 
  {if (a<8) x=2 else x=4}

# WHILE
#
ages=c(1,4,15,3,9,21,25,12,40)
n=0
while (ages[n+1]<20)
{
  n=n+1
}
# other way
n=0
s=0
while (ages[n+1]<20)
{
  s=s+ages[n+1]
  n=n+1
}
avage=s/n
#
# Avoid For Loops with apply type functions
#
# apply function
#
scube=function(x)
{
  y=sum(x^3)
  return(y)
}
m=matrix(1:24, 4,6)
cubecolsums=rep(0,6)
for (j in (1:6))
  cubecolsums[j]=scube(m[,j])
# apply
z=apply(m, 2, scube)
y=apply(m, 1, scube)
#
pow=function(a,n)
  return(sum(a^n))
z1=apply(m, 2, pow, n=1/2)
y1=apply(m, 2, pow, a=1/2)
#
# using functions as arguments of other functions
#
test=function(x, f)
{
  return(f(x))
}
x=1:10
test(x, mean)
test(x, sd)
test(x,scube)
test(x, pow(x, n=2))
#
## PLOTS
#
x=1:10
y=x^2
plot(y~x)
plot(y~x, cex=0.5)
plot(y~x, cex=0.9, pch="2")
plot(y~x, cex=0.9, pch="+", col="red")
plot(y~x, cex=0.9, pch="+", col=4)
plot(y~x, cex=0.9, pch="+", col="red", type="l")
x=1:3
y=x^2
plot(y~x, type="l")
x=c(3,2,1,7,6,5,4,10,9,8)
y=x^2
plot(y~x)  
plot(y~x, type="l")  
x1=sort(x)
y1=x1^2
plot(y1~x1, type="n")
x=1:10
y=x^2
z=x^3
plot(y~x, type="l")
plot(z~x)
points(y~x, col="red")
lines(y~x, col="red")
#
plot(y~x, type="l")
points(z~x, col="blue")
#
plot(y~x, type="l", ylim=c(0,1500))
points(z~x, col="blue")
